<?php

namespace App\Http\Controllers;

use App\Models\DiaDeAtencion;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Request;

class DiaDeAtencionController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index(): JsonResponse
    {
        $items = DiaDeAtencion::all();

        return response()->json([
            'success' => true,
            'data' => $items,
            'message' => 'Registros obtenidos correctamente',
        ], 200);
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request): JsonResponse
    {
        $payload = $request->only((new DiaDeAtencion())->getFillable());
        $diaDeAtencion = DiaDeAtencion::create($payload);

        return response()->json([
            'success' => true,
            'data' => $diaDeAtencion,
            'message' => 'Registro creado correctamente',
        ], 201);
    }

    /**
     * Display the specified resource.
     */
    public function show(DiaDeAtencion $diaDeAtencion): JsonResponse
    {
        return response()->json([
            'success' => true,
            'data' => $diaDeAtencion,
            'message' => 'Registro obtenido correctamente',
        ], 200);
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, DiaDeAtencion $diaDeAtencion): JsonResponse
    {
        $payload = $request->only((new DiaDeAtencion())->getFillable());
        $diaDeAtencion->update($payload);

        return response()->json([
            'success' => true,
            'data' => $diaDeAtencion,
            'message' => 'Registro actualizado correctamente',
        ], 200);
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(DiaDeAtencion $diaDeAtencion): JsonResponse
    {
        $diaDeAtencion->delete();

        return response()->json([
            'success' => true,
            'message' => 'Registro eliminado correctamente',
        ], 200);
    }
}